package classroom;

import java.awt.*;
import java.io.*;
import javax.sound.sampled.*;


public class Lock extends javax.swing.JPanel {

    int id;
    boolean permission=false;
    boolean status=false;
    boolean lastState=false;
    String lastRut="";
    Image imageLocked, imageUnLocked;
    File soundFile = new File("res/beep.wav");
    ClientTCP clienttcp;

    public Lock() {
        initComponents();
        loadImage();
        
    }

    public void setId(int id){
        this.id=id;
        clienttcp=new ClientTCP(id);
    }

    public void loadImage() {
        imageLocked = getToolkit().getImage("res/redlight.png");
        imageUnLocked = getToolkit().getImage("res/greenlight.png");
    }
    
    public void paint(Graphics g) {
        Graphics2D g2d=(Graphics2D)g;
        if(!status)g2d.drawImage(imageLocked, 0, 0, this);
        if(status)g2d.drawImage(imageUnLocked, 0, 0, this);
        g2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);
        Font font = new Font("arial", Font.BOLD, 13);
        g2d.setFont(font);
        g2d.drawString(lastRut, 26, 32);
    }

    public void checkCard(String readedId){
        if(MainForm.cardPicked.getX()>this.getX()-50 && MainForm.cardPicked.getX()<this.getX()+50 && MainForm.cardPicked.getY()>this.getY()+80 && MainForm.cardPicked.getY()<this.getY()+120){
            
            if(status==lastState  && !lastRut.equals(MainForm.cardPicked.rut)){
                
                
                try {
                    AudioInputStream audioIn = AudioSystem.getAudioInputStream(soundFile);
                    Clip clip = AudioSystem.getClip();
                    clip.open(audioIn);
                    clip.start();
                    
                    System.out.println(""+MainForm.cardPicked.rut);

                    lastRut=MainForm.cardPicked.rut;
                    status=clienttcp.RunClient(MainForm.cardPicked.rut);

                } catch (Exception ex) {
                    //-------------
                }


                repaint();
                

            }


        }
        else{
            lastState=status;
            lastRut="";
            //repaint();
        }



    }


    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 179, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 207, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents


    // Variables declaration - do not modify//GEN-BEGIN:variables
    // End of variables declaration//GEN-END:variables

}
